package testing;

import static org.junit.jupiter.api.Assertions.*;

import java.io.*;
import org.junit.jupiter.api.Test;

import product.*;
import product.io.*;

class ProductFileProcessorTest {

    @Test
    void coverage() {
        new ProductFileProcessor();
    }
    
    @Test
    void roundTripTeethbrush() throws IOException {
        Teethbrush s = new Teethbrush("M1005", 5, false);
        s.changeInventory(10);
        ProductFileProcessor.writeTeethbrush(s);
        
        Teethbrush t = ProductFileProcessor.readTeethbrush("M1005");
        assertEquals("M1005", t.getModel());
        assertEquals(5, t.getHardness());
        assertFalse(t.isPolished());
        assertEquals(10, t.getInventory());
    }
    
    @Test
    void roundTripElectricTeethbrush() throws IOException {
        ElectricTeethbrush s = new ElectricTeethbrush("E1003", 3, true, false, true);
        s.changeInventory(550);
        ProductFileProcessor.writeElectricTeethbrush(s);
        
        ElectricTeethbrush t = ProductFileProcessor.readElectricTeethbrush("E1003");
        assertEquals("E1003", t.getModel());
        assertEquals(3, t.getHardness());
        assertTrue(t.isPolished());
        assertFalse(t.isRechargeable());
        assertTrue(t.isUltrasonic());
        assertEquals(550, t.getInventory());
    }
}
